package chaincode

import (
	"errors"
	"fmt"
)

type PingRecord struct {
	Key   string `json:"key,omitempty"`
	Value string `json:"value,omitempty"`
}

func (this PingRecord) GetObjectType() string  {
	return "PingRecord";
}

func (this PingRecord) CheckBeforeAdd(manager IManager) error {
	return nil
}

func (this PingRecord) New() ValidObject {
	return &PingRecord{}
}

func (this PingRecord) CheckBeforeUpdate(updatedObject ValidObject, manager IManager) error {
	return nil
}

func (this PingRecord) GetKey(manager IManager) []string {
	txID := manager.GetTxID()
	time := manager.GetTime()

	key := fmt.Sprintf("key_ping_%s_%s_%d", this.Key, txID, time)
	return []string{key}
}

func (this PingRecord) Validate() error {
	if len(this.Key) == 0 {
		return errors.New("Key is empty")
	}

	return nil
}
